package guestbook;

import java.util.Date;

import javax.jdo.annotations.IdGeneratorStrategy;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.jdo.annotations.PrimaryKey;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import com.google.appengine.api.users.User;

@PersistenceCapable
@XmlRootElement(name = "greeting")
public class Greeting {
	
	@PrimaryKey
    @Persistent(valueStrategy = IdGeneratorStrategy.IDENTITY)
    private Long key;

    @Persistent
    private User author;

    @Persistent
    private String content;

    @Persistent
    private Date date;
    
    public Greeting() {}

    public Greeting(User author, String content, Date date) {
        this.author = author;
        this.content = content;
        this.date = date;
    }
    
    @XmlElement
    public Long getKey() {
        return key;
    }

    public User getAuthor() {
        return author;
    }
    
    @XmlElement
    public String getEmail() {
    	if(author != null) {
    		return author.getEmail();
    	}
    	else {
    		return null;
    	}
    }

    @XmlElement
    public String getContent() {
        return content;
    }
    
    @XmlElement
    public Date getDate() {
        return date;
    }

    public void setAuthor(User author) {
        this.author = author;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public void setDate(Date date) {
        this.date = date;
    }
}