package guestbook;


import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.jdo.PersistenceManager;
import javax.ws.rs.Consumes;
import javax.ws.rs.DELETE;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;

import com.google.appengine.api.users.User;
import com.google.appengine.api.users.UserService;
import com.google.appengine.api.users.UserServiceFactory;

@Path("/message/")
public class GreetingService {
    
    @GET
    @Produces("application/json")
    public List<Greeting> getGreetings() {
    	PersistenceManager pm = PM.get();
    	String query = "select from " + Greeting.class.getName() + " order by date desc";
        List<Greeting> result = (List<Greeting>) pm.newQuery(query).execute();
        List<Greeting> greetings = new ArrayList<Greeting>(result);
	    pm.close();
	    return greetings;
    }

    @GET
    @Produces("application/json")
    @Path("/{id}/")
    public Greeting getGreeting(@PathParam("id") Long id) {
		PersistenceManager pm = PM.get();
		Greeting greeting = (Greeting) pm.getObjectById(Greeting.class, id);
	    pm.close();
    	return greeting;
    }

    @PUT
    @Consumes("text/plain")
    @Produces("application/json")
    public Greeting addGreeting(String data) {
	        PersistenceManager pm = PM.get();
	        UserService userService = UserServiceFactory.getUserService();
	        User user = userService.getCurrentUser();
	        Date date = new Date();
	        Greeting greeting = new Greeting(user, data, date);
	        try {
        		pm.makePersistent(greeting);
	        } finally {
	            pm.close();
	        }
    	return greeting;
    }
    
    @POST
    @Consumes("application/x-www-form-urlencoded")
    @Produces("application/json")
    @Path("/{id}/")
    public Greeting changeGreeting(@PathParam("id") Long id, @FormParam("content") String data) {
    	PersistenceManager pm = PM.get();
		Greeting greeting = (Greeting) pm.getObjectById(Greeting.class, id);
		greeting.setContent(data);
	    pm.makePersistent(greeting);
	    pm.close();
	    return greeting;
    }
    
    @DELETE
    public void deleteGreetings() {
    	PersistenceManager pm = PM.get();
	    String query = "select from " + Greeting.class.getName() + " order by date desc";
	    List<Greeting> greetings = (List<Greeting>) pm.newQuery(query).execute();
	    pm.deletePersistentAll(greetings);
	    pm.close();
    }
    
    @DELETE
    @Path("/{id}/")
    public void deleteGreeting(@PathParam("id") Long id) {
		PersistenceManager pm = PM.get();
		Greeting greeting = (Greeting) pm.getObjectById(Greeting.class, id);
	    pm.deletePersistent(greeting);
	    pm.close();
    }
}