<%@ page language="java" contentType="text/html; utf-8" pageEncoding="utf-8" %>
<%@ page isELIgnored="false" %> 

<%@ page import="java.util.List" %>
<%@ page import="javax.jdo.PersistenceManager" %>
<%@ page import="guestbook.Greeting" %>
<%@ page import="guestbook.PM" %>

<%@ taglib prefix="c"  uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="my" tagdir="/WEB-INF/tags/mytags" %> 

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; utf-8">
<title>Test</title>

<!-- std apis -->
<script src="http://www.google.com/uds/solutions/cscintro/stdlib.js" type="text/javascript"></script>
<link href="http://www.google.com/uds/solutions/cscintro/stdlib.css" rel="stylesheet" type="text/css"/>

<script type="text/javascript">
	var greetings = [];
    var gLog;
    
    function main() {
      gLog = new StdLog(document.getElementById("log"), "stdout");
      getGreetings();
    }

    function printGreetings() {
    	
      clearGreetings();
    	
	  var messages = document.getElementById("messages");
      
      for (i=0; i < greetings.length; i++) {
    	 var message = document.createElement("div");
    	 message.setAttribute("id", greetings[i].key)
    	 var author = document.createElement("b");
    	 if(greetings[i].email) {
    	 	author.appendChild(document.createTextNode(greetings[i].email));
    	 }
    	 else {
    		 author.appendChild(document.createTextNode("Anonymous"));
    	 }
    	 message.appendChild(author);
    	 var content = document.createElement("blockquote");
    	 content.appendChild(document.createTextNode(greetings[i].content));
    	 message.appendChild(content);
    	 var link = document.createElement("a");
    	 link.appendChild(document.createTextNode("delete"));
    	 link.setAttribute("href", "javascript:deleteMessage(" + greetings[i].key + ")");
    	 message.appendChild(link);
    	 messages.appendChild(message);
      }
    }
    
    function clearGreetings() {
    	var messages = document.getElementById("messages");
    	messages.innerHTML = "";
    }
    
    function getGreetings() {
    	var url = "/rest/message/";
    	var client = new XMLHttpRequest();
    	
    	client.open("GET", url, false);
    	client.send();
    	
    	if (client.status == 200) {
    		var response = JSON.parse(client.responseText);
    		//gLog.printLine(client.responseText);
    		greetings = [];
    		if(response) {
    			greetings = greetings.concat(greetings, response.greeting);
    		}
    		printGreetings();
    	}
    	else {
    	    gLog.printLine("The request did not succeed!\n\nThe response status was: " + client.status + " " + client.statusText + ".");
    	}
    }
    
    function putGreeting() {
    	var url = "/rest/message/";
    	var client = new XMLHttpRequest();
    	var textarea = document.getElementById("content");
    	var greeting = textarea.value;
    	textarea.value = "";
 
    	
    	client.open("PUT", url, false);
    	client.setRequestHeader("Content-Type", "text/plain");
    	client.send(greeting);
    	if (client.status == 200) {
    		getGreetings();
    		printGreetings();
    	}
    	else {
    	    gLog.printLine("The request did not succeed!\n\nThe response status was: " + client.status + " " + client.statusText + ".");
    	}
    }
    
    function deleteMessages() {
    	var url = "/rest/message/";
    	var client = new XMLHttpRequest();
    	
    	client.open("DELETE", url, false);
    	client.send();
    	
    	if (client.status == 204) {
    		getGreetings();
    		printGreetings();
    	}
    	else {
    	    gLog.printLine("The request did not succeed!\n\nThe response status was: " + client.status + " " + client.statusText + ".");
    	}
    }
    
    function deleteMessage(key) {
    	var url = "/rest/message/" + key;
    	var client = new XMLHttpRequest();
    	
    	client.open("DELETE", url, false);
    	client.send();
    	
    	if (client.status == 204) {
    		getGreetings();
    		printGreetings();
    	}
    	else {
    	    gLog.printLine("The request did not succeed!\n\nThe response status was: " + client.status + " " + client.statusText + ".");
    	}
    }
</script> 

</head>

<body onload="main()">

<my:login>Here will be login</my:login>

<form>
   <div><textarea id="content" rows="3" cols="60"></textarea></div>
   <div><input type="button" value="Post Greeting" onclick="javascript:putGreeting()"/></div>
</form>
<a href="javascript:deleteMessages()">Delete the guestbook</a>

<div id="messages">Loading messages ...</div>

<div id="log">Loading ...</div>

</body>
</html>